package org.zipcoder.store;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        if(entries.size() == 0){return true;} else {return false;}
    }

    @Override
    public Cart get(User key) {
        for(Entry entry : entries){
            if(entry.getKey().equals(key)){
                return entry.getValue();
            }
        }
        return null;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        Entry entry = new Entry(key, value);
        boolean added = false;

        for(Entry entry1 : entries){
            if(entry1.getKey().equals(key)){
                entries.remove(entry1);
                entries.add(entry);
                added = true;
                break;
            }
        }
        if(!added){
            entries.add(entry);
        }
    }


    @Override
    public List<User> getKeys() {
        List<User> keys = new ArrayList<>();

        for(Entry entry : entries){
            keys.add(entry.getKey());
        }

        return keys;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> values = new ArrayList<>();

        for(Entry entry : entries){
            values.add(entry.getValue());
        }

        return values;
    }

    @Override
    public Cart remove(User key) {
        Iterator<Entry> entries = this.entries.iterator();

        while(entries.hasNext()){
            Entry entry = entries.next();
            if(entry.getKey().equals(key)){
                Entry removeEnt = entry;
                entries.remove();
                return removeEnt.getValue();
            }
        }
        return null;
    }
}
